%global debug_package %{nil}

Name:           metslib
Version:        0.5.3
Release:    1%{?dist}
Summary:        Metaheuristic modeling framework and optimization toolkit in modern C++

License:        GPLv3+ or CPL
URL:            https://projects.coin-or.org/metslib
Source0:        http://www.coin-or.org/download/source/%{name}/%{name}-%{version}.tgz
Patch0:         %{name}-0.5.3-noarch.patch
Patch1:         %{name}-0.5.3-boost.patch
Patch2:         %{name}-0.5.3-cpp17.patch

BuildRequires: make
BuildRequires:  gcc-c++
BuildRequires:  doxygen
BuildRequires:  boost-devel
BuildRequires:  graphviz

%description
%{summary}.

%package        devel
Summary:        Metaheuristic modeling framework and optimization toolkit in modern C++
Provides:       %{name}-static = %{version}-%{release}
BuildArch:      noarch
Requires:       boost-devel

%description    devel
METSlib is a metaheuristic modeling framework and optimization toolkit in
modern C++ released as Free/Libre/Open Source Software.

Model and algorithms are modular: any search algorithm can be applied to the
same model. On the other hand no assumption is made on the model, you can
work on any problem type: timetabling, assignment problems, vehicle routing,
bin-packing and so on.

Once you have implemented your model in the problem framework, the library
makes easy testing different Tabu Search strategies or even different
algorithms (Simulated Annealing or other local search based algorithms) with
a few lines of code.

%package doc
Summary:     Documentation for %{name}
BuildArch:   noarch

%description doc
The %{name}-doc package provides documentation for the %{name} library.

%prep
%setup -q
%patch0 -p0
%patch1 -p1 -b .boost
%patch2 -p1 -b .cpp17
sed -i 's| -O3||g' configure

%build
export CXXFLAGS="%{optflags} --std=gnu++14"
%configure 
make %{?_smp_mflags}
doxygen doxydoc/doxygen.conf

%install
%make_install
mkdir -p %{buildroot}%{_datadir}
mv %{buildroot}%{_libdir}/pkgconfig %{buildroot}%{_datadir}

%check
export CXXFLAGS="%{optflags}" 
make test

%files devel
%doc AUTHORS COPYING NEWS README 
%{_includedir}/*
%{_datadir}/pkgconfig/*.pc

%files doc
%doc doxydoc/html COPYING

%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.3-1
- initial build
